<template>
  <div
    v-if="loading"
    class="column flex-center"
  >
    <q-spinner-dots
      color="primary"
      size="24px"
    />
  </div>

  <div
    v-else-if="plot"
    class="q-gutter-y-sm text-body2"
  >
    <div class="row items-center">
      <div class="col">
        <div class="cursor-pointer">
          {{ plot.name }}
          <q-icon
            name="las la-pen"
            class="q-ml-xs"
            size="xs"
          />
          <q-popup-edit
            v-model="newPlotName"
            v-slot="scope"
            buttons
            :label-set="$gettext('Save')"
            :label-cancel="$gettext('Cancel')"
            @save="onNewPlotName"
          >
            <q-input
              v-model="scope.value"
              dense
              autofocus
              :rules="[
                val => Boolean(newPlotName) || $gettext('Enter a name')
              ]"
              :hint="$gettext('Type a name')"
            />
          </q-popup-edit>
        </div>
      </div>
      <div class="col-auto text-grey-7">
        <span
          v-if="plotSurfaceDisplay"
          class="q-ml-xs"
        >
          {{ plotSurfaceDisplay }}
        </span>
      </div>
    </div>
  </div>
</template>

<script>
import { formatSurface } from 'src/services/display-surface-unit'

export default {
  name: 'PlotInformation',
  props: {
    plot: {
      type: Object,
      default: null
    },
    loading: {
      type: Boolean,
      default: false
    }
  },
  emits: ['on-rename-plot'],
  data () {
    return {
      newPlotName: this.plot?.name ?? null
    }
  },
  computed: {
    plotName () {
      return this.plot?.name
    },
    plotSurfaceDisplay () {
      return formatSurface(this.plot?.area, { displayTinySurfaceInM2: true })
    }
  },
  watch: {
    plot (newVal) {
      if (newVal?.name) {
        this.newPlotName = newVal?.name
      }
    }
  },
  methods: {
    onNewPlotName (newPlotName) {
      this.$emit('on-rename-plot', newPlotName)
    }
  }
}
</script>
